using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.TeamFoundation.Server;
using Microsoft.Office.Interop.Outlook;
using Microsoft.Office.Core;

namespace TXLooker.Common.Core
{
    public interface IProjectProvider
    {
        /// <summary>
        /// 
        /// </summary>
        IServerProvider ServerProvider { get; }
        /// <summary>
        /// 
        /// </summary>
        string ProjectName { get; }
        /// <summary>
        /// 
        /// </summary>
        Uri ProjectUri { get; }
        /// <summary>
        /// 
        /// </summary>
        /// <returns></returns>
        ProjectInfo GetProjectInfo();

        /// <summary>
        /// 
        /// </summary>
        MAPIFolder Folder { get; }
        /// <summary>
        /// 
        /// </summary>
        object SyncFolderObject { get; }

        void Update();
        event EventHandler BeginUpdate;
        event EventHandler EndUpdate;

        event TFEventHandler<CommandBar> InitializeContextMenu;

    }
}
