using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Office.Interop.Outlook;
using Microsoft.Office.Core;

namespace TXLooker.Common.Core
{
    public interface ITeamFoundationDataProvider
    {
        IEnumerable<IServerProvider> Servers { get; }

        IServerProvider GetServer( string uri );
        IServerProvider GetServer( Uri uri );        

        event TFEventHandler<IEnumerable<IServerProvider>> NewServers;
        event TFEventHandler<IEnumerable<IServerProvider>> PreRemoveServers;

        void Update();
    }
}
