using System;
using System.Collections.Generic;

namespace TXLooker.Common.Core
{
    [Serializable]
    public class ProjectStore
    {
        private string m_project;
        private List<string> m_users;

        public ProjectStore()
        { }

        public ProjectStore(string project,List<string> users)
        {
            this.ProjectName = project;
            this.Users = users;
        }

        public string ProjectName
        {
            get { return this.m_project; }
            set { this.m_project = value; }
        }

        public List<string> Users
        {
            get { return this.m_users; }
            set { this.m_users = value; }
        }

        //public IEnumerable<string> GetUsers()
        //{
        //    foreach (string s in this.m_users)
        //        yield return s;
        //}
        public IEnumerator<string> GetEnumerator()
        {
            foreach (string user in this.Users)
                yield return user;
        }
    }
}
