using System.ComponentModel;

namespace TXLooker.WorkItemExtention.UI.QueryManager
{
    [TypeConverter(typeof(QueryConverter))]
    public class Query
    {
        // Fields
        private string m_query;

        // Methods
        public Query()
            : this("")
        {
        }

        public Query(string query)
        {
            this.m_query = query;
        }

        // Properties
        public string QueryValue
        {
            get
            {
                return this.m_query;
            }
            set
            {
                this.m_query = value;
            }
        }
    }
}