namespace TXLooker.WorkItemExtention.WIQL
{
    using System;
    using System.Globalization;

    public interface IExternal
    {
        object FindField(string name, object tableTag);
        object FindTable(string name);
        object FindVariable(string name);
        DataType GetFieldDataType(object fieldTag);
        DataType GetVariableDataType(object varTag);
        Node OptimizeNode(Node node, NodeTableName tableContext, NodeFieldName fieldContext);
        void VerifyNode(Node node, NodeTableName tableContext, NodeFieldName fieldContext);

        System.Globalization.CultureInfo CultureInfo { get; }

        System.TimeZone TimeZone { get; }
    }
}

