namespace TXLooker.WorkItemExtention.WIQL
{
    using System;

    public enum SyntaxError
    {
        NoError,
        DateConstantFormat,
        DuplicateFrom,
        DuplicateGroupBy,
        DuplicateOrderBy,
        DuplicateWhere,
        DuplicateAsOf,
        EverNotEqualOperator,
        ExpectingBoolean,
        ExpectingBy,
        ExpectingClosingQuote,
        ExpectingClosingSquareBracket,
        ExpectingComparisonOperator,
        ExpectingCondition,
        ExpectingConst,
        ExpectingEndOfString,
        ExpectingFieldList,
        ExpectingFieldName,
        ExpectingLeftBracket,
        ExpectingRightBracket,
        ExpectingSelect,
        ExpectingTableName,
        ExpectingValue,
        ExpectingDate,
        FieldDoesNotExistInTheTable,
        GroupByIsNotSupported,
        InOperatorWithTreePathField,
        IncompatibleRightConst,
        InvalidConditionalOperator,
        InvalidNodeType,
        ContainsWorksForStringsOnly,
        NonSortableField,
        PathMustBeAStringNotStartingWithBackslash,
        StringIsNotANumber,
        TableDoesNotExist,
        TooComplexEverOperator,
        TreePathIsNotFoundInHierarchy,
        UnderCanBeUsedForTreePathFieldOnly,
        UnknownFieldType,
        UnknownOrIncompatibleTypesInTheList,
        FromIsNotSpecified,
        InvalidConditionForLongTextField,
        InvalidConditionForTreeField,
        NonQueryableField,
        VariableDoesNotExist,
        UnknownVariableType,
        NonQueriableNodeField,
        InvalidConditionForNodeField,
        InvalidProjectName,
        ProjectNotFound,
        WrongTypeForArithmetic,
        InvalidLongTextSearchForWhitespace,
        WrongTypeForArithmeticRightOperand,
        NonZeroTime,
        InvalidConditionForEmptyString,
        EverWithDatePrecision
    }
}

