using System;
using System.Collections.Generic;
using System.Text;

namespace TeamXpand
{
    public class ServerConfigItem : ICloneable
    {
        /// <summary>
        /// 
        /// </summary>
        public string ServerURI
        {
            get { return this.m_serverURI;  }
            set { this.m_serverURI = value; }
        }
        private string m_serverURI = string.Empty;

        /// <summary>
        /// Form Team Explorer settings
        /// </summary>
        public bool IsTeamExplorer
        {
            get { return this.m_bTeamExplorer;  }
            set { this.m_bTeamExplorer = value; }
        }
        private bool m_bTeamExplorer = false;

        /// <summary>
        /// Needed Project URIs from server
        /// </summary>
        public List<string> ProjectURIs
        {
            get { return this.m_projectURIs; }
        }
        private List<string> m_projectURIs = new List<string>();

        public object Clone()
        {
            ServerConfigItem clone = new ServerConfigItem();
            clone.ServerURI = this.ServerURI;
            clone.IsTeamExplorer = this.IsTeamExplorer;
            clone.ProjectURIs.AddRange(this.ProjectURIs);
            return clone;
        }

    }
}
