using System;
using System.Collections.Generic;
using System.Runtime.InteropServices.ComTypes;
using Microsoft.Office.Core;
using Microsoft.Office.Interop.Outlook;
using TeamXpandLicence.ObjectExchange;
using MAPIFolder = Microsoft.Office.Interop.Outlook.MAPIFolder;

namespace TXLooker.Common.Core
{
    public interface IExtentionDataProvider : ITeamFoundationDataProvider
    {
        // Properties
        Application Application { get; }
        MAPIFolder AppMAPIFolderRoot { get; }
        CommandBarPopup AppMenuItemRoot { get; }
        string AppStoreFolderPath { get; }
        string AppStoreID { get; }
        IntPtr Hwnd { get; }
        LicenceType LicenceType { get; set; }
        IEnumerable<MAPIFolder> OlStandardFolders { get; }
        NameSpace Session { get; }
        IRibbonUI RibbonUI { get; }
        IStream Stream { get; set; }
    }

 

}
