using System;
using Microsoft.TeamFoundation.WorkItemTracking.Client;

namespace TXLooker.WorkItemExtention.UI.QueryManager
{
    public class AllowSaveQueryEventArgs : EventArgs
    {
        private StoredQuery m_storedQuery;
        private bool m_newQuery;
        string m_queryText;

        public AllowSaveQueryEventArgs(StoredQuery storedQuery,string queryText ,bool newQuery)
        {
            this.NewQuery = newQuery;
            this.Query = storedQuery;
            this.m_queryText = queryText;
        }

        public string QueryText
        {
            get { return this.m_queryText; }
            private set { this.m_queryText = value; }
        }

        public StoredQuery Query
        {
            get { return this.m_storedQuery; }
            private set { this.m_storedQuery = value; }
        }

        public bool NewQuery
        {
            get { return this.m_newQuery; }
            private set { this.m_newQuery = value; }
        }
    }
}