using System.Runtime.InteropServices;

namespace TXLooker.WorkItemExtention.UI.QueryManager
{
    [StructLayout(LayoutKind.Sequential, Size = 1)]
    internal struct ConstantOperators
    {
        public const string Equal = "=";
        public const string NotEqual = "<>";
        public const string Major = ">";
        public const string MajorEqual = ">=";
        public const string Atomic = "<";
        public const string AtomicEqual = "<=";
        public const string IN = "IN";
        public const string In = "In";
        public const string UNDER = "UNDER";
        public const string Under = "Under";
        public const string CONTAINS = "CONTAINS";
        public const string Contains = "Contains";
        public const string NOT_CONTAINS = "NOT CONTAINS";
        public const string Does_Not_Contain = "Does Not Contain";
        public const string EVER = "EVER";
        public const string Was_Ever = "Was Ever";
        public const string NOT_UNDER = "NOT UNDER";
        public const string Not_Under = "Not Under";
        public const string XmlNotEquals = "&lt;&gt;";
        public const char ForwardBracket = '(';
        public const char BackBracket = ')';
        public const char Apostrophe = '\'';
    }
}