using System;

namespace TXLooker.WorkItemExtention.UI.QueryManager
{
    [Serializable]
    public class QueryParameters
    {
        // Fields
        private string m_AndOr;
        private string m_Field;
        private string m_Oparator;
        private string m_Value;

        // Methods
        public QueryParameters()
        {
        }

        public QueryParameters(string andOr, string field, string oper, string value)
            : this()
        {
            this.m_AndOr = andOr;
            this.m_Field = field;
            this.m_Oparator = oper;
            this.m_Value = value;
        }

        // Properties
        public string AndOr
        {
            get
            {
                return this.m_AndOr;
            }
            set
            {
                this.m_AndOr = value;
            }
        }

        public string Field
        {
            get
            {
                return this.m_Field;
            }
            set
            {
                this.m_Field = value;
            }
        }

        public string Operator
        {
            get
            {
                return this.m_Oparator;
            }
            set
            {
                this.m_Oparator = value;
            }
        }

        public string Value
        {
            get
            {
                return this.m_Value.Replace("/'", string.Empty);
            }
            set
            {
                this.m_Value = value;
            }
        }
    }

 

}