using System;
using Microsoft.TeamFoundation.WorkItemTracking.Client;
using TXLooker.WorkItemExtention.Core;

namespace TXLooker.WorkItemExtention.UI.QueryManager
{
    public class SavedQueryEventArgs : EventArgs
    {
        private StoredQuery m_query;
        private Core.WIObject m_wiObject;
     
        public SavedQueryEventArgs(StoredQuery query, Core.WIObject wiObject)
        {
            this.Query = query;
            this.WIObject = wiObject;
        }

        public WIObject WIObject
        {
            get { return this.m_wiObject; }
            private set { this.m_wiObject = value; }
        }

        public StoredQuery Query
        {
            get { return this.m_query; }
            private set { this.m_query = value; }
        }
    }
}