namespace TXLooker.WorkItemExtention.WIQL
{
    using System;
    using System.Collections;

    public class NodeEnumerator : IEnumerator
    {
        private int m_index = -1;
        private Node m_node;

        internal NodeEnumerator(Node node)
        {
            this.m_node = node;
        }

        public bool MoveNext()
        {
            return (++this.m_index < this.m_node.Count);
        }

        public void Reset()
        {
            this.m_index = -1;
        }

        public object Current
        {
            get
            {
                return this.m_node[this.m_index];
            }
        }
    }
}

