namespace TXLooker.WorkItemExtention.WIQL
{
    using System;
    using System.Reflection;

    public abstract class NodeItem : Node
    {
        private string m_string;

        protected NodeItem(NodeType type, string s) : base(type)
        {
            this.m_string = s;
        }

        public override string ToString()
        {
            return this.m_string;
        }

        public override int Count
        {
            get
            {
                return 0;
            }
        }

        public override bool IsScalar
        {
            get
            {
                return true;
            }
        }

        public override Node this[int i]
        {
            get
            {
                return null;
            }
            set
            {
            }
        }

        public override Priority Priority
        {
            get
            {
                return Priority.Operand;
            }
        }

        public string Value
        {
            get
            {
                return this.m_string;
            }
            set
            {
                this.m_string = value;
            }
        }
    }
}

