namespace TXLooker.WorkItemExtention.WIQL
{
    using System;

    public class NodeName : NodeItem
    {
        public NodeName(string s) : base(NodeType.Name, s)
        {
        }

        public override string ToString()
        {
            return Tools.FormatName(base.Value);
        }

        public override DataType DataType
        {
            get
            {
                return DataType.Unknown;
            }
        }

        public override bool IsConst
        {
            get
            {
                return false;
            }
        }
    }
}

