using System;

namespace TXLooker.Core
{
    public class RegistrationExcepton : SystemException
    {
        // Fields
        private string m_helpLink;
        private string m_message;

        // Methods
        public RegistrationExcepton()
        {
        }

        public RegistrationExcepton(string message)
            : this()
        {
            this.m_message = message;
        }

        public RegistrationExcepton(string message, string helpLink)
            : this(message)
        {
            this.m_helpLink = helpLink;
        }

        // Properties
        public new string HelpLink
        {
            get
            {
                return this.m_helpLink;
            }
            protected set
            {
                this.m_helpLink = value;
            }
        }

        public new string Message
        {
            get
            {
                return this.m_message;
            }
            protected set
            {
                this.m_message = value;
            }
        }
    }

 

}