﻿using System;

namespace TeamXpandLicence.ObjectExchange
{
    [Serializable]
    public class RegistrationLicenceDataObjectOut : ILicenceDataObjectOut
    {
        private LicenceType m_licenseType;
        private int m_timeLeft;
        private bool m_registrationOk;

        public RegistrationLicenceDataObjectOut()
        { }

        public RegistrationLicenceDataObjectOut(int timeLeft, LicenceType licenseType, bool registrationOk)
            : this()
        {
            this.LicenceType = licenseType;
            this.TimeLicenceLeft = timeLeft;
            this.m_registrationOk = registrationOk;
        }

        public bool RegistrationOk
        {
            get { return this.m_registrationOk; }
            set { this.m_registrationOk = value; }
        }

        public LicenceType LicenceType
        {
            get { return this.m_licenseType; }
            set { this.m_licenseType = value; }
        }

        public int TimeLicenceLeft
        {
            get { return this.m_timeLeft; }
            set { m_timeLeft = value; }
        }
    }
}
